; 
; Modified 2005-01-05 U.Neudecker
    .486                        ; force 32 bit code
    .model flat, stdcall        ; memory model & calling convention
    option casemap :none        ; case sensitive
; 
; 
include \masm32\include\masm32.inc
include \masm32\macros\macros.asm
include \masm32\include\timers.asm


includelib \masm32\lib\masm32.lib
.code

; 

.code
align 16
  ; --------------------------------------
  ; scan string for match
  ; Returning 0   : Match
  ;           1   ; str1 > str2
  ;          -1   ; str1 < str2
  ; --------------------------------------

;#######################################################################
;  DWORD-wise 
;#######################################################################
StrComp proc uses edi, str1:DWORD, str2:DWORD, strlen:dword
    mov ecx, str1
    mov edx, str2
    mov edi, strlen
        
    mov al, [ecx]                 ; precheck
    cmp al, byte ptr [edx]
    jne no_match2

    shr edi, 2
    .while edi > 0
        mov eax, [ecx]
        cmp eax, [edx]
        jne no_match1
        add edx, 4
        add ecx, 4        
        dec edi
    .endw    
    mov edi, strlen
    and edi, 3
    .while edi > 0
        mov al, [ecx]
        cmp al, byte ptr [edx]
        jne no_match2
        add edx, 1
        add ecx, 1        
        dec edi
    .endw
    
    xor eax, eax
    ret

  no_match2:
      .if al < byte ptr[edx]
        mov eax, dword ptr[-1]
      .else
      mov eax, 1
    .endif
    ret

  no_match1:
      mov ecx, [edx]
      bswap eax             ; to get the right byte-order !
      bswap ecx
      .if eax < ecx
        mov eax, dword ptr[-1]
      .else
        mov eax, 1
      .endif
      ret
  
StrComp endp

align 16


align 16
;#######################################################################
;  REPE CMPSD 
;#######################################################################
StrComp4 proc uses ebx ecx edx edi, str1:DWORD, str2:DWORD, strlen:dword
    mov esi, str1
    mov edi, str2
    mov ecx, strlen            

    shr ecx, 2
    cld

    repe cmpsd
    je @F

      mov eax, [esi - 4]
      mov ebx, [edi - 4]
      bswap eax
      bswap ebx    
      .if eax < ebx
        mov eax, dword ptr[-1]
      .else
      mov eax, 1
    .endif
    ret

@@: 
    mov ecx, strlen
    and ecx, 3
    
    repe cmpsb
    je @F
      movzx eax, byte ptr[esi - 1]
      movzx ebx, byte ptr[edi - 1]
  
      .if eax < ebx
        mov eax, dword ptr[-1]
      .else
      mov eax, 1
    .endif
    ret

@@:
    xor eax, eax
    ret

StrComp4 endp


align 16
;#######################################################################
;  REPE CMPSB 
;#######################################################################
StrComp5 proc uses ebx ecx edx edi, str1:DWORD, str2:DWORD, strlen:dword
    mov esi, str1
    mov edi, str2
    mov ecx, strlen            

    cld

    repe cmpsb
    je @F 
    
    mov al, [esi - 1]
      .if al < [edi - 1]
        mov eax, dword ptr[-1]
      .else
      mov eax, 1
    .endif
    ret

@@:        
    xor eax, eax
    ret

StrComp5 endp

end
